/*************************************************************

	customBG.xml
	by leechbite.com
	
	lifted off KameleonDUI for custom background XUI

*************************************************************/

#include <lib/std.mi>
#include <lib/config.mi>

// non exposed attribs page
#define CUSTOM_PAGE_NONEXPOSED "{E9C2D926-53CA-400f-9A4D-85E31755A4CF}"

Global group scriptGroup;
Global layer bgImage, bgImageRef;
Global guiObject bgColor, bgGroup, refOverlay;
Global int noreflect;

Global configAttribute bkground_image_attrib;

System.onScriptLoaded() {
  
  
  ConfigItem custom_page_nonexposed = Config.newItem("Hidden", CUSTOM_PAGE_NONEXPOSED);
  bkground_image_attrib = custom_page_nonexposed.newAttribute(getSkinName()+" Background Image", "IMAGE:player.main.background.default;0");

  scriptGroup = getScriptGroup();
  bgImage = scriptGroup.getObject("bgImage");
  bgColor = scriptGroup.getObject("bgColor");
  bgGroup = scriptGroup.getObject("bgGroup");
  bgImageRef = scriptGroup.getObject("bgimage.ref");
  refOverlay = scriptGroup.getObject("bg.fademask");
  
	bgImageRef.fx_setBgFx(0);
	bgImageRef.fx_setWrap(0);
	bgImageRef.fx_setBilinear(1);
	bgImageRef.fx_setAlphaMode(0);
	bgImageRef.fx_setGridSize(1,1);
	bgImageRef.fx_setRect(1);
	bgImageRef.fx_setClear(0); //left as zero as cover is a static image and we dont need to redraw
	bgImageRef.fx_setLocalized(1);
	bgImageRef.fx_setRealtime(0);
 
  bkground_image_attrib.onDataChanged();
}

System.onScriptUnloading() {
  return;
}

bkground_image_attrib.onDataChanged() {
  string bkData = strupper(getData());

  string strtemp = "", bkDataEntry1 = "", bkDataEntry2 = "";
  strtemp = getToken(bkData, ";" ,0);
  if (strtemp!="") bkDataEntry1 = strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1);
  strtemp = getToken(bkData, ";" ,1);
  if (strtemp!="") bkDataEntry2 = strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1);

  if (strLeft(bkData,5)=="IMAGE") {
	bgImageRef.fx_setEnabled(0);
	  
    bgColor.hide();
    bgGroup.hide();    bgGroup.setXMLParam("groupid", "");
    bgImage.show();    bgImage.setXMLParam("image", bkDataEntry1);
    if (!noreflect) { bgImageRef.show();	bgImageRef.setXMLParam("image", bkDataEntry1); }
    if (bkDataEntry2=="") bkDataEntry2="0";
    bkDataEntry2 = "0";
    bgImage.setXMLParam("tile", bkDataEntry2);
    bgImageRef.setXMLParam("tile", bkDataEntry2);
    
    bgImageRef.fx_setEnabled(1);
	bgImageRef.fx_restart();
	
  } else if (strLeft(bkData,3)=="RGB") {
    bgColor.show();
    bgGroup.hide();    bgGroup.setXMLParam("groupid", "");
    bgImage.hide();
    bgImageRef.hide();
    bgColor.setXMLParam("color", bkDataEntry1);
  } else if (strLeft(bkData,5)=="GROUP") {
    bgColor.hide();
    bgImage.hide();
    bgImageRef.hide();
    bgGroup.show();
    bgGroup.setXMLParam("groupid", bkDataEntry1);
  }
}

bgImageRef.fx_onGetPixelY(double r, double d, double x, double y) {
	return -y;
}

System.onSetXuiParam(String param, String value) {
	param = strlower(param);
	if (param=="noreflection") {
		noreflect = stringtointeger(value);
		if (noreflect) {
			refOverlay.hide();
			bgImageRef.hide();
			bgImage.setXMLParam("h","100");
		} else {
			refOverlay.show();
			bgImage.setXMLParam("h","60");
			bkground_image_attrib.onDataChanged();
		}
	}
}


